#include <common.h>

// 
unsigned int u_adc_5v,u_adc_12v,u_adc_pow,U_adc_acc;
unsigned char U_step;
unsigned char acc_tmp=0,acc=0,standby=1;

static unsigned char time_out=0;

//  
static void avr_init(void);	//
void pause_min(unsigned char min);
// 



#define led_on	PORTD|=_BV(PD3)
#define led_off	PORTD&=~_BV(PD3)

#define pow_on	PORTB|=_BV(PB2)
#define pow_off	PORTB&=~_BV(PB2)

#define pow_sec_on	PORTB|=_BV(PB1);_delay_ms(300);PORTB&=~_BV(PB1);

#define pow_sec_off	PORTB|=_BV(PB1);_delay_ms(1000);PORTB&=~_BV(PB1);

#define pc_regular_off					led_on;_delay_ms(50);led_off;_delay_ms(50);



// TIMER0
ISR(TIMER0_OVF_vect)
{
	

	
	return;
}

// TIMER2
ISR(TIMER2_OVF_vect)
{
	return;
}
ISR(TIMER2_COMP_vect)
{
	return;
}


//  
int main(void)
{
	avr_init();	
	_delay_ms(1000);
	
	//sei();
	
	for(;;)
    {	
		
		//     
		acc_tmp=keyD(PD2);
		if (acc_tmp!=acc)
		{
			acc=acc_tmp;
			if (acc==0)
			{
				standby=1;
				led_off;
				for(time_out=0;time_out<10;time_out++) pause(400);
				pow_sec_off;
				for(time_out=0;time_out<50;time_out++) pause(400);
				pow_off;
			}
			if (acc==1)
			{
				standby=0;
				led_on;
				
				pause(400);
				
				ADMUX&=0xf0;ADMUX |=0x07;
				ADCSRA |= 0x40;
				
				pause(400);
				
				u_adc_pow= res_ADC()*5;
				if (u_adc_pow>=11600)
				{
					pow_on;
					pause(400);
					pause(400);
					pow_sec_on;
				}
				if (u_adc_pow<11600)
				{
					pause(4000);
					if (u_adc_pow<11600)
					{
						pow_off;
						for(;;)
						{
							led_on;
							_delay_ms(50);
							led_off;
							_delay_ms(50);
						}
					}
				}	
			}
		}
		
		if (standby==0) //  
		{
			//   
			
			ADMUX&=0xf0;ADMUX |=0x07;
			ADCSRA |= 0x40;
			_delay_ms(10);
			
			u_adc_pow= res_ADC()*5;
			if (u_adc_pow<11000)
			{
				_delay_ms(500);
				ADMUX&=0xf0;ADMUX |=0x07;
				ADCSRA |= 0x40;
				_delay_ms(10);
				u_adc_pow= res_ADC()*5;
					
				if (u_adc_pow<11000) pow_off;
			}
			
			//if (keyB(PB0)==0) //     
			//{
				_delay_ms(500);
				if (keyB(PB0)==0)
				{
					//  
					ADMUX&=0xf0;ADMUX |=0x01;
					ADCSRA |= 0x40;
					_delay_ms(10);
					u_adc_12v= res_ADC()*5;
					
					if ((u_adc_12v<11000)|(u_adc_12v>13000))
					{
						_delay_ms(500);
						ADMUX&=0xf0;ADMUX |=0x01;
						ADCSRA |= 0x40;
						_delay_ms(10);
						u_adc_12v= res_ADC()*5;
						if ((u_adc_12v<4000)|(u_adc_12v>5700)) pow_off;
					}
					
					ADMUX&=0xf0;ADMUX |=0x00;
					ADCSRA |= 0x40;
					_delay_ms(10);
					u_adc_5v= res_ADC()*5;
					if ((u_adc_5v<4000)|(u_adc_5v>5700))
					{
						_delay_ms(500);
						ADMUX&=0xf0;ADMUX |=0x00;
						ADCSRA |= 0x40;
						_delay_ms(10);
						u_adc_5v= res_ADC()*5;
						if ((u_adc_5v<4000)|(u_adc_5v>5700)) pow_off;
					}
				}
			//}	
		}
		
		//    
		if (standby==1)
		{
			pc_regular_off;
			_delay_ms(10000);
			_delay_ms(10000);
			pow_off;
			
			ADMUX&=0xf0;ADMUX |=0x07;
			ADCSRA |= 0x40;
			_delay_ms(10);
			u_adc_pow= res_ADC()*5;
			
			if (u_adc_pow<11000)
			{
				_delay_ms(1000);
				ADMUX&=0xf0;ADMUX |=0x07;
				ADCSRA |= 0x40;
				_delay_ms(10);
				u_adc_pow= res_ADC()*5;
					
				if (u_adc_pow<11000)
				{
					pow_off;
					
					led_on;
					_delay_ms(50);
					led_off;
					_delay_ms(50);
					
				}
			}
			
		}
		
		
	}
	
}                 
static void avr_init(void)
{
//   

	PORTB=0b00000001;
	DDRB= 0b00000110;
	
	DDRD= 0b00001011;
	PORTD=0b00000000;
	
	//   ()
	DDRC=0x00;
	PORTC=0x00;
	
	//  
	
	ADMUX &= 0xDF & 0x7F & 0xF1; ADMUX |= 0x40 | 0x06;   
	ADCSRA &= 0xFB; ADCSRA |= 0x80 | 0x00 | 0x20 | 0x03; 
	
//  
	MCUCR= 0b00000000;
	GICR= 0b00000000;
	MCUCSR=0x00;	
	
//   
	//TIMSK=0;
	//T0
	//TCCR0= 0b00000011;
	
	
	//T2
	
	//TCCR2 = 0b00011001; 	//    
	//TCCR2 = 0b01101001; 	// FAst PWM 
	//TCNT2= 0x00;	
	//OCR2= 0x7f;
	
	//T1
	//TCCR1A=0b00000000;
	//TCCR1B=0b00000001;
	//TCCR1C=0b00000000;

    return;
}

void pause_min(unsigned char min)
{
	unsigned char i_min=0;
	for (i_min=0;i_min<=min;i_min++)_delay_ms(1000);
	return;
}
